#include <framebuffer.h>

int fb_write_pixel_8bit(struct fb *f, unsigned int x, unsigned int y, unsigned int r, unsigned int g, unsigned int b) {
	unsigned char pixel = (((r >> 6) << 4) & 0x30) | (((b >> 6) << 2) & 0xC) | ((g >> 6) & 0x3);
	((char*) (f->device->fbaddr))[y*f->device->pixelwidth + x] = pixel;
	return 0;
}

int fb_write_pixel_16bit(struct fb *f, unsigned int x, unsigned int y, unsigned int r, unsigned int g, unsigned int b) {
	unsigned int pixel = (((r >> 3) << 10) & 0x7BF6) | (((b >> 3) << 5) & 0x3E0) | ((g >> 3) & 0x1F);
	((char*)f->device->fbaddr)[(y*f->device->pixelwidth + x) << 1] = (char)pixel;
	((char*)f->device->fbaddr)[((y*f->device->pixelwidth + x) << 1) + 1] = (char)(pixel >> 8);
	return 0;
}

int fb_write_pixel_24bit(struct fb *f, unsigned int x, unsigned int y, unsigned int r, unsigned int g, unsigned int b) {
	((char*)f->device->fbaddr)[(y*f->device->pixelwidth + x)*3] = (char)r;
	((char*)f->device->fbaddr)[(y*f->device->pixelwidth + x)*3 + 1] = (char)b;
	((char*)f->device->fbaddr)[(y*f->device->pixelwidth + x)*3 + 2] = (char)g;
	return 0;
}

int fb_write_pixel(struct fb *f, unsigned int x, unsigned int y, unsigned int r, unsigned int g, unsigned int b) {
	if (f->device->color_depth == FB_COLOR_DEPTH_8)
		return fb_write_pixel_8bit(f, x, y, r, g, b);
	else if (f->device->color_depth == FB_COLOR_DEPTH_16)
		return fb_write_pixel_16bit(f, x, y, r, g, b);
	else if (f->device->color_depth == FB_COLOR_DEPTH_24)
		return fb_write_pixel_24bit(f, x, y, r, g, b);
	return -1;
}
